/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.TipoCorte;
import com.rjconsultores.ventaboletos.service.TipoCorteService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("editarTipoCorteController")
@Scope("prototype")
public class EditarTipoCorteController extends MyGenericForwardComposer {

    @Autowired
    private TipoCorteService tipoCorteService;
    private TipoCorte tipoCorte;
    private MyListbox tipoCorteList;
    private Button btnApagar;
    private MyTextbox txtNome;
    private static Logger log = Logger.getLogger(EditarTipoCorteController.class);

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public TipoCorte getTipoCorte() {
        return tipoCorte;
    }

    public void setTipoCorte(TipoCorte tipoCorte) {
        this.tipoCorte = tipoCorte;
    }

    public MyTextbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(MyTextbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        tipoCorte = (TipoCorte) Executions.getCurrent().getArg().get("tipoCorte");
        tipoCorteList = (MyListbox) Executions.getCurrent().getArg().get("tipoCorteList");

        if (tipoCorte.getTipocorteId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();

        try {
            tipoCorte.setActivo(Boolean.TRUE);
            tipoCorte.setFecmodif(Calendar.getInstance().getTime());
            tipoCorte.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());

            List<TipoCorte> lsTipoCorte = tipoCorteService.buscar(tipoCorte.getDesctipo());

            if (!lsTipoCorte.isEmpty()) {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarTipoCorteController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else {
                if (tipoCorte.getTipocorteId() == null) {
                    tipoCorteService.suscribir(tipoCorte);
                    tipoCorteList.addItem(tipoCorte);
                } else {
                    tipoCorteService.actualizacion(tipoCorte);
                    tipoCorteList.updateItem(tipoCorte);
                }

                Messagebox.show(
                        Labels.getLabel("editarTipoCorteController.MSG.suscribirOK"),
                        Labels.getLabel("editarTipoCorteController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error("editarTipoCorteController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarTipoCorteController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarTipoCorteController.MSG.borrarPergunta"),
                    Labels.getLabel("editarTipoCorteController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                tipoCorteService.borrar(tipoCorte);

                Messagebox.show(
                        Labels.getLabel("editarTipoCorteController.MSG.borrarOK"),
                        Labels.getLabel("editarTipoCorteController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                tipoCorteList.removeItem(tipoCorte);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
